# Hat, lightweight workers for your Rabbit

Hat is a light weight distributed worker framework backed by RabbitMQ built on top of Celluloid and Bunny with the goal
of providing the developer the ability to easily the most powerful features of Rabbit while remaining simple to
understand and flexible to use.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'rabbit-hat'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install rabbit-hat

## Basic Usage

### A simple worker

Hat workers are designed to follow similar patterns to that of other background task frameworks such as Resque or
Sidekiq. At a minimum the worker needs to inherit from the `Hat::Worker` class and have a `#perform` instance method.

```ruby
class SimpleWorker < Hat::Worker

  def perform(message)
    # ... process all the things ...
  end

end
```

The worker can then be run using the `hat` command:

```bash
hat start simple_worker.rb
```

#### A note on worker file naming

Similar to Rails, hat assumes that a standard file naming convention is being used. Example:

* ```simple_worker.rb``` becomes ```SimpleWorker```
* ```examples/subscriber.rb``` becomes ```Examples::Subscriber```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release` to create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

1. Fork it ( https://github.com/[my-github-username]/rabbit-hat/fork )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
